org.springframework.jdbc.datasource.embedded

## Class EmbeddedDatabaseFactoryBean

- java.lang.Object
- - org.springframework.jdbc.datasource.embedded.EmbeddedDatabaseFactory
  - - org.springframework.jdbc.datasource.embedded.EmbeddedDatabaseFactoryBean

- All Implemented Interfaces:
    DisposableBean, FactoryBean<DataSource>, InitializingBean

      public class EmbeddedDatabaseFactoryBean
      extends EmbeddedDatabaseFactory
      implements FactoryBean<DataSource>, InitializingBean, DisposableBean

  A subclass of `EmbeddedDatabaseFactory` that implements `FactoryBean` for registration as a Spring bean. Returns the actual `DataSource` that provides connectivity to the embedded database to Spring.

  The target DataSource is returned instead of a `EmbeddedDatabase` proxy since the FactoryBean will manage the initialization and destruction lifecycle of the database instance.

  Implements DisposableBean to shutdown the embedded database when the managing Spring container is shutdown.

  Since:
    3.0
  Author:
    Keith Donald, Juergen Hoeller

- - ### Constructor Summary

    Constructors
    Constructor and Description
    `EmbeddedDatabaseFactoryBean()`

  - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `void` | `afterPropertiesSet()` Invoked by a BeanFactory after it has set all bean properties supplied (and satisfied BeanFactoryAware and ApplicationContextAware).
    `void` | `destroy()` Invoked by a BeanFactory on destruction of a singleton.
    `DataSource` | `getObject()` Return an instance (possibly shared or independent) of the object managed by this factory.
    `Class<? extends DataSource>` | `getObjectType()` Return the type of object that this FactoryBean creates, or `null` if not known in advance.
    `boolean` | `isSingleton()` Is the object managed by this factory a singleton? That is, will `FactoryBean.getObject()` always return the same object (a reference that can be cached)?
    `void` | `setDatabaseCleaner(DatabasePopulator databaseCleaner)` Set a script execution to be run in the bean destruction callback, cleaning up the database and leaving it in a known state for others.

    - ### Methods inherited from class org.springframework.jdbc.datasource.embedded.EmbeddedDatabaseFactory

      `getDatabase, getDataSource, initDatabase, setDatabaseConfigurer, setDatabaseName, setDatabasePopulator, setDatabaseType, setDataSourceFactory, shutdownDatabase`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Constructor Detail

    - #### EmbeddedDatabaseFactoryBean

          public EmbeddedDatabaseFactoryBean()

  - ### Method Detail

    - #### setDatabaseCleaner

          public void setDatabaseCleaner(DatabasePopulator databaseCleaner)

      Set a script execution to be run in the bean destruction callback, cleaning up the database and leaving it in a known state for others.
      Parameters:
        `databaseCleaner` - the database script executor to run on destroy
      See Also:
        `EmbeddedDatabaseFactory.setDatabasePopulator(org.springframework.jdbc.datasource.init.DatabasePopulator)`, `DataSourceInitializer.setDatabaseCleaner(org.springframework.jdbc.datasource.init.DatabasePopulator)`

    - #### afterPropertiesSet

          public void afterPropertiesSet()

      Description copied from interface: `InitializingBean`
      Invoked by a BeanFactory after it has set all bean properties supplied (and satisfied BeanFactoryAware and ApplicationContextAware).

      This method allows the bean instance to perform initialization only possible when all bean properties have been set and to throw an exception in the event of misconfiguration.

      Specified by:
        `afterPropertiesSet` in interface `InitializingBean`

    - #### destroy

          public void destroy()

      Description copied from interface: `DisposableBean`
      Invoked by a BeanFactory on destruction of a singleton.
      Specified by:
        `destroy` in interface `DisposableBean`

    - #### getObject

          public DataSource getObject()

      Description copied from interface: `FactoryBean`
      Return an instance (possibly shared or independent) of the object managed by this factory.

      As with a `BeanFactory`, this allows support for both the Singleton and Prototype design pattern.

      If this FactoryBean is not fully initialized yet at the time of the call (for example because it is involved in a circular reference), throw a corresponding `FactoryBeanNotInitializedException`.

      As of Spring 2.0, FactoryBeans are allowed to return `null` objects. The factory will consider this as normal value to be used; it will not throw a FactoryBeanNotInitializedException in this case anymore. FactoryBean implementations are encouraged to throw FactoryBeanNotInitializedException themselves now, as appropriate.

      Specified by:
        `getObject` in interface `FactoryBean<DataSource>`
      Returns:
        an instance of the bean (can be `null`)
      See Also:
        `FactoryBeanNotInitializedException`

    - #### getObjectType

          public Class<? extends DataSource> getObjectType()

      Description copied from interface: `FactoryBean`
      Return the type of object that this FactoryBean creates, or `null` if not known in advance.

      This allows one to check for specific types of beans without instantiating objects, for example on autowiring.

      In the case of implementations that are creating a singleton object, this method should try to avoid singleton creation as far as possible; it should rather estimate the type in advance. For prototypes, returning a meaningful type here is advisable too.

      This method can be called before this FactoryBean has been fully initialized. It must not rely on state created during initialization; of course, it can still use such state if available.

      NOTE: Autowiring will simply ignore FactoryBeans that return `null` here. Therefore it is highly recommended to implement this method properly, using the current state of the FactoryBean.

      Specified by:
        `getObjectType` in interface `FactoryBean<DataSource>`
      Returns:
        the type of object that this FactoryBean creates, or `null` if not known at the time of the call
      See Also:
        `ListableBeanFactory.getBeansOfType(java.lang.Class<T>)`

    - #### isSingleton

          public boolean isSingleton()

      Description copied from interface: `FactoryBean`
      Is the object managed by this factory a singleton? That is, will `FactoryBean.getObject()` always return the same object (a reference that can be cached)?

      NOTE: If a FactoryBean indicates to hold a singleton object, the object returned from `getObject()` might get cached by the owning BeanFactory. Hence, do not return `true` unless the FactoryBean always exposes the same reference.

      The singleton status of the FactoryBean itself will generally be provided by the owning BeanFactory; usually, it has to be defined as singleton there.

      NOTE: This method returning `false` does not necessarily indicate that returned objects are independent instances. An implementation of the extended `SmartFactoryBean` interface may explicitly indicate independent instances through its `SmartFactoryBean.isPrototype()` method. Plain `FactoryBean` implementations which do not implement this extended interface are simply assumed to always return independent instances if the `isSingleton()` implementation returns `false`.

      Specified by:
        `isSingleton` in interface `FactoryBean<DataSource>`
      Returns:
        whether the exposed object is a singleton
      See Also:
        `FactoryBean.getObject()`, `SmartFactoryBean.isPrototype()`